"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.APIRefPage = APIRefPage;
const react_1 = __importStar(require("react"));
const lodash_flatten_1 = __importDefault(require("lodash.flatten"));
const classnames_1 = __importDefault(require("classnames"));
const component_1 = require("@teambit/component");
const documenter_ui_heading_1 = require("@teambit/documenter.ui.heading");
const ui_foundation_ui_hooks_use_is_mobile_1 = require("@teambit/ui-foundation.ui.hooks.use-is-mobile");
const base_react_navigation_link_1 = require("@teambit/base-react.navigation.link");
const ui_foundation_ui_react_router_use_query_1 = require("@teambit/ui-foundation.ui.react-router.use-query");
const ui_foundation_ui_buttons_collapser_1 = require("@teambit/ui-foundation.ui.buttons.collapser");
const base_ui_surfaces_split_pane_hover_splitter_1 = require("@teambit/base-ui.surfaces.split-pane.hover-splitter");
const base_ui_surfaces_split_pane_split_pane_1 = require("@teambit/base-ui.surfaces.split-pane.split-pane");
const api_reference_hooks_use_api_1 = require("@teambit/api-reference.hooks.use-api");
const api_reference_explorer_api_reference_explorer_1 = require("@teambit/api-reference.explorer.api-reference-explorer");
const api_reference_hooks_use_api_ref_url_1 = require("@teambit/api-reference.hooks.use-api-ref-url");
const api_reference_utils_sort_api_nodes_1 = require("@teambit/api-reference.utils.sort-api-nodes");
const design_ui_round_loader_1 = require("@teambit/design.ui.round-loader");
const design_ui_empty_box_1 = require("@teambit/design.ui.empty-box");
const component_modules_component_url_1 = require("@teambit/component.modules.component-url");
const lanes_hooks_use_lanes_1 = require("@teambit/lanes.hooks.use-lanes");
const lanes_ui_models_lanes_model_1 = require("@teambit/lanes.ui.models.lanes-model");
const api_reference_page_module_scss_1 = __importDefault(require("./api-reference-page.module.scss"));
// @todo - this will be fixed as part of the @teambit/base-react.navigation.link upgrade to latest
const Link = base_react_navigation_link_1.Link;
function APIRefPage({ rendererSlot, className }) {
    var _a, _b, _c;
    const component = (0, react_1.useContext)(component_1.ComponentContext);
    const lanes = (0, lanes_hooks_use_lanes_1.useLanes)();
    const renderers = (0, lodash_flatten_1.default)(rendererSlot.values());
    const { apiModel, loading } = (0, api_reference_hooks_use_api_1.useAPI)(component.id.toString(), renderers);
    const isMobile = (0, ui_foundation_ui_hooks_use_is_mobile_1.useIsMobile)();
    const [isSidebarOpen, setSidebarOpenness] = (0, react_1.useState)(!isMobile);
    const [mounted, setMounted] = (0, react_1.useState)(false);
    react_1.default.useEffect(() => {
        setMounted(true);
    }, []);
    const sidebarOpenness = isSidebarOpen ? base_ui_surfaces_split_pane_split_pane_1.Layout.row : base_ui_surfaces_split_pane_split_pane_1.Layout.left;
    const selectedAPIFromUrl = (0, api_reference_hooks_use_api_ref_url_1.useAPIRefParam)('selectedAPI');
    react_1.default.useEffect(() => {
        window.scrollTo(0, 0);
    }, [selectedAPIFromUrl]);
    const apiNodes = (apiModel && (0, lodash_flatten_1.default)(Array.from(apiModel.apiByType.values())).sort(api_reference_utils_sort_api_nodes_1.sortAPINodes)) || [];
    const isEmpty = apiNodes.length === 0;
    const apiTree = (0, react_1.useMemo)(() => {
        return apiNodes.map((apiNode) => {
            var _a;
            if (!apiNode.exported)
                return `_Internals/${apiModel === null || apiModel === void 0 ? void 0 : apiModel.internalAPIKey(apiNode.api)}`;
            return `${(_a = apiNode.renderer) === null || _a === void 0 ? void 0 : _a.nodeType}/${apiNode.alias || apiNode.api.name}`;
        });
    }, [apiNodes.length]);
    const getIcon = (node) => {
        var _a, _b, _c;
        const nodeType = node.id.split('/')[0];
        if (nodeType === '_Internals') {
            const apiNode = apiModel === null || apiModel === void 0 ? void 0 : apiModel.apiByName.get(node.id.replace('_Internals/', ''));
            const icon = (_a = apiNode === null || apiNode === void 0 ? void 0 : apiNode.renderer.icon) === null || _a === void 0 ? void 0 : _a.url;
            return icon || undefined;
        }
        const icon = (_c = (_b = apiModel === null || apiModel === void 0 ? void 0 : apiModel.apiByType.get(nodeType)) === null || _b === void 0 ? void 0 : _b[0].renderer.icon) === null || _c === void 0 ? void 0 : _c.url;
        return icon || undefined;
    };
    const selectedAPINode = (selectedAPIFromUrl &&
        ((apiModel === null || apiModel === void 0 ? void 0 : apiModel.apiByName.get(selectedAPIFromUrl)) ||
            (apiModel === null || apiModel === void 0 ? void 0 : apiModel.apiByName.get(selectedAPIFromUrl.replace('_Internals/', ''))))) ||
        apiNodes[0];
    const selectedAPIName = (selectedAPINode && selectedAPINode.exported
        ? `${(_a = selectedAPINode === null || selectedAPINode === void 0 ? void 0 : selectedAPINode.renderer) === null || _a === void 0 ? void 0 : _a.nodeType}/${(selectedAPINode === null || selectedAPINode === void 0 ? void 0 : selectedAPINode.alias) || (selectedAPINode === null || selectedAPINode === void 0 ? void 0 : selectedAPINode.api.name)}`
        : selectedAPINode && `_Internals/${apiModel === null || apiModel === void 0 ? void 0 : apiModel.internalAPIKey(selectedAPINode.api)}`) || apiTree[0];
    const SelectedAPIComponent = selectedAPINode && selectedAPINode.renderer.Component;
    const query = (0, ui_foundation_ui_react_router_use_query_1.useQuery)();
    if (loading) {
        return (react_1.default.createElement("div", { className: api_reference_page_module_scss_1.default.loader },
            react_1.default.createElement(design_ui_round_loader_1.RoundLoader, null)));
    }
    if (!apiModel || isEmpty) {
        return react_1.default.createElement(design_ui_empty_box_1.EmptyBox, { title: 'There is no API extracted for this component.', link: '', linkText: '' });
    }
    const icon = selectedAPINode.renderer.icon;
    const name = selectedAPINode.api.name;
    const componentVersionFromUrl = query.get('version');
    const filePath = selectedAPINode.api.location.filePath;
    const pathname = component_modules_component_url_1.ComponentUrl.toUrl(component.id, { includeVersion: false, useLocationOrigin: true });
    const componentUrlWithoutVersion = pathname === null || pathname === void 0 ? void 0 : pathname.split('~')[0];
    const viewedLaneId = (_c = (_b = lanes.lanesModel) === null || _b === void 0 ? void 0 : _b.viewedLane) === null || _c === void 0 ? void 0 : _c.id;
    const laneComponentUrl = viewedLaneId && !viewedLaneId.isDefault() && mounted
        ? `${window.location.origin}${lanes_ui_models_lanes_model_1.LanesModel.getLaneComponentUrl(component.id, viewedLaneId)}/~code/${filePath}${componentVersionFromUrl ? `?version=${componentVersionFromUrl}` : ''}`
        : undefined;
    const mainComponentUrl = `${componentUrlWithoutVersion}/~code/${filePath}${componentVersionFromUrl ? `?version=${componentVersionFromUrl}` : ''}`;
    const locationUrl = laneComponentUrl || mainComponentUrl;
    return (react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.SplitPane, { layout: sidebarOpenness, size: "85%", className: (0, classnames_1.default)(className, api_reference_page_module_scss_1.default.apiRefPageContainer) },
        react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.Pane, { className: api_reference_page_module_scss_1.default.left },
            react_1.default.createElement("div", { className: api_reference_page_module_scss_1.default.selectedAPIDetailsContainer },
                react_1.default.createElement("div", { className: api_reference_page_module_scss_1.default.apiNodeDetailsNameContainer },
                    icon && (react_1.default.createElement("div", { className: api_reference_page_module_scss_1.default.apiTypeIcon },
                        react_1.default.createElement("img", { src: icon.url }))),
                    react_1.default.createElement(documenter_ui_heading_1.H1, { size: 'md', className: api_reference_page_module_scss_1.default.name }, name),
                    react_1.default.createElement(SelectedAPILocation, { locationUrl: locationUrl })),
                SelectedAPIComponent && (react_1.default.createElement(SelectedAPIComponent, { apiNode: selectedAPINode, apiRefModel: apiModel, renderers: renderers, depth: 0 })))),
        react_1.default.createElement(base_ui_surfaces_split_pane_hover_splitter_1.HoverSplitter, { className: api_reference_page_module_scss_1.default.splitter },
            react_1.default.createElement(ui_foundation_ui_buttons_collapser_1.Collapser, { placement: "left", isOpen: isSidebarOpen, onMouseDown: (e) => e.stopPropagation(), onClick: () => setSidebarOpenness((x) => !x), tooltipContent: `${isSidebarOpen ? 'Hide' : 'Show'} file tree`, className: api_reference_page_module_scss_1.default.collapser })),
        react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.Pane, { className: (0, classnames_1.default)(api_reference_page_module_scss_1.default.right, api_reference_page_module_scss_1.default.dark) },
            react_1.default.createElement(api_reference_explorer_api_reference_explorer_1.APIReferenceExplorer, { selectedAPIName: selectedAPIName, apiTree: apiTree, getIcon: getIcon }))));
}
function SelectedAPILocation({ locationUrl }) {
    return (react_1.default.createElement(Link, { external: true, href: locationUrl, className: api_reference_page_module_scss_1.default.locationLink },
        react_1.default.createElement("div", { className: api_reference_page_module_scss_1.default.locationLabel }, "View Code"),
        react_1.default.createElement("div", { className: api_reference_page_module_scss_1.default.locationIcon },
            react_1.default.createElement("img", { src: "https://static.bit.dev/design-system-assets/Icons/external-link.svg" }))));
}
//# sourceMappingURL=api-reference-page.js.map